from random import randint
import math

def greedyHeuristic(objects, capacity):
    S = [0 for i in objects]
    SWeight = 0
    SBenefit = 0
    objectsSorted = sorted(objects)
    while len(objectsSorted) != 0:
        if SWeight + objectsSorted[0].weight <= capacity:
            #print("Added object: " + objectsSorted[0].__str__())
            S[objectsSorted[0].id - 1] = 1
            SWeight += objectsSorted[0].weight
            SBenefit += objectsSorted[0].benefit
            #print(str(SWeight))
            #print(str(SBenefit))
            #print(str(S))
            #input("Type anything to continue")
        objectsSorted.remove(objectsSorted[0])
    return S, SBenefit, SWeight

def partiallyGreedyHeuristic(objects, capacity, alpha):
    S = [0 for i in objects]
    SWeight = 0
    SBenefit = 0
    objectsSorted = sorted(objects)
    while len(objectsSorted) != 0:
        tamLRC = math.ceil(1 + alpha * (len(objectsSorted) - 1))
        candidate = randint(0, tamLRC - 1)        
        if SWeight + objectsSorted[candidate].weight <= capacity:
            #print("Added object: " + objectsSorted[candidate].__str__())
            S[objectsSorted[candidate].id - 1] = 1
            SWeight += objectsSorted[candidate].weight
            SBenefit += objectsSorted[candidate].benefit
            #print(str(candidate))
            #print(str(SWeight))
            #print(str(SBenefit))
            #print(str(S))
            #input("Type anything to continue")
        objectsSorted.remove(objectsSorted[candidate])
    return S, SBenefit, SWeight

